Index: trunk/tests/phpunit/testcases/groups/class-bp-group-member-query.php
===================================================================
--- trunk/tests/phpunit/testcases/groups/class-bp-group-member-query.php	(revision 9120)
+++ trunk/tests/phpunit/testcases/groups/class-bp-group-member-query.php	(revision 9139)
@@ -22,7 +22,7 @@
 	public function test_with_include() {
 		$g = $this->factory->group->create();
-		$u1 = $this->create_user();
-		$u2 = $this->create_user();
-		$u3 = $this->create_user();
+		$u1 = $this->factory->user->create();
+		$u2 = $this->factory->user->create();
+		$u3 = $this->factory->user->create();
 		$time = time();
 
@@ -42,7 +42,7 @@
 	public function test_with_group_role_null() {
 		$g = $this->factory->group->create();
-		$u1 = $this->create_user();
-		$u2 = $this->create_user();
-		$u3 = $this->create_user();
+		$u1 = $this->factory->user->create();
+		$u2 = $this->factory->user->create();
+		$u3 = $this->factory->user->create();
 		$time = time();
 
@@ -70,7 +70,7 @@
 	public function test_with_group_role_member() {
 		$g = $this->factory->group->create();
-		$u1 = $this->create_user();
-		$u2 = $this->create_user();
-		$u3 = $this->create_user();
+		$u1 = $this->factory->user->create();
+		$u2 = $this->factory->user->create();
+		$u3 = $this->factory->user->create();
 		$time = time();
 
@@ -95,7 +95,7 @@
 	public function test_with_group_role_mod() {
 		$g = $this->factory->group->create();
-		$u1 = $this->create_user();
-		$u2 = $this->create_user();
-		$u3 = $this->create_user();
+		$u1 = $this->factory->user->create();
+		$u2 = $this->factory->user->create();
+		$u3 = $this->factory->user->create();
 		$time = time();
 
@@ -119,7 +119,7 @@
 
 	public function test_with_group_role_admin() {
-		$u1 = $this->create_user();
-		$u2 = $this->create_user();
-		$u3 = $this->create_user();
+		$u1 = $this->factory->user->create();
+		$u2 = $this->factory->user->create();
+		$u3 = $this->factory->user->create();
 		$g  = $this->factory->group->create( array(
 			'creator_id' => $u1
@@ -147,7 +147,7 @@
 	public function test_with_group_role_member_mod() {
 		$g = $this->factory->group->create();
-		$u1 = $this->create_user();
-		$u2 = $this->create_user();
-		$u3 = $this->create_user();
+		$u1 = $this->factory->user->create();
+		$u2 = $this->factory->user->create();
+		$u3 = $this->factory->user->create();
 		$time = time();
 
@@ -171,7 +171,7 @@
 
 	public function test_with_group_role_member_admin() {
-		$u1 = $this->create_user();
-		$u2 = $this->create_user();
-		$u3 = $this->create_user();
+		$u1 = $this->factory->user->create();
+		$u2 = $this->factory->user->create();
+		$u3 = $this->factory->user->create();
 		$g  = $this->factory->group->create( array(
 			'creator_id' => $u1,
@@ -198,7 +198,7 @@
 
 	public function test_with_group_role_mod_admin() {
-		$u1 = $this->create_user();
-		$u2 = $this->create_user();
-		$u3 = $this->create_user();
+		$u1 = $this->factory->user->create();
+		$u2 = $this->factory->user->create();
+		$u3 = $this->factory->user->create();
 		$g  = $this->factory->group->create( array(
 			'creator_id' => $u1,
@@ -225,7 +225,7 @@
 
 	public function test_with_group_role_member_mod_admin() {
-		$u1 = $this->create_user();
-		$u2 = $this->create_user();
-		$u3 = $this->create_user();
+		$u1 = $this->factory->user->create();
+		$u2 = $this->factory->user->create();
+		$u3 = $this->factory->user->create();
 		$g  = $this->factory->group->create( array(
 			'creator_id' => $u1,
@@ -252,8 +252,8 @@
 
 	public function test_with_group_role_member_mod_admin_banned() {
-		$u1 = $this->create_user();
-		$u2 = $this->create_user();
-		$u3 = $this->create_user();
-		$u4 = $this->create_user();
+		$u1 = $this->factory->user->create();
+		$u2 = $this->factory->user->create();
+		$u3 = $this->factory->user->create();
+		$u4 = $this->factory->user->create();
 		$g  = $this->factory->group->create( array(
 			'creator_id' => $u1,
@@ -287,6 +287,6 @@
 	public function test_with_group_role_banned() {
 		$g = $this->factory->group->create();
-		$u1 = $this->create_user();
-		$u2 = $this->create_user();
+		$u1 = $this->factory->user->create();
+		$u2 = $this->factory->user->create();
 		$time = time();
 
@@ -308,5 +308,5 @@
 	public function test_group_has_no_members_of_role_mod() {
 		$g = $this->factory->group->create();
-		$u1 = $this->create_user();
+		$u1 = $this->factory->user->create();
 		$time = time();
 
@@ -324,6 +324,6 @@
 	public function test_confirmed_members() {
 		$g = $this->factory->group->create();
-		$u1 = $this->create_user();
-		$u2 = $this->create_user();
+		$u1 = $this->factory->user->create();
+		$u2 = $this->factory->user->create();
 		$time = time();
 
@@ -351,6 +351,6 @@
 	public function test_get_with_type_last_joined() {
 		$g = $this->factory->group->create();
-		$u1 = $this->create_user();
-		$u2 = $this->create_user();
+		$u1 = $this->factory->user->create();
+		$u2 = $this->factory->user->create();
 		$time = time();
 
@@ -377,6 +377,6 @@
 	public function test_get_with_type_first_joined() {
 		$g = $this->factory->group->create();
-		$u1 = $this->create_user();
-		$u2 = $this->create_user();
+		$u1 = $this->factory->user->create();
+		$u2 = $this->factory->user->create();
 		$time = time();
 
@@ -404,7 +404,7 @@
 	public function test_get_with_type_group_activity_with_activity_component_disabled() {
 		$g = $this->factory->group->create();
-		$u1 = $this->create_user();
-		$u2 = $this->create_user();
-		$u3 = $this->create_user();
+		$u1 = $this->factory->user->create();
+		$u2 = $this->factory->user->create();
+		$u3 = $this->factory->user->create();
 		$c = buddypress()->groups->id;
 		$time = time();
@@ -475,7 +475,7 @@
 	public function test_get_with_type_group_activity() {
 		$g = $this->factory->group->create();
-		$u1 = $this->create_user();
-		$u2 = $this->create_user();
-		$u3 = $this->create_user();
+		$u1 = $this->factory->user->create();
+		$u2 = $this->factory->user->create();
+		$u3 = $this->factory->user->create();
 		$c = buddypress()->groups->id;
 		$time = time();
@@ -532,5 +532,5 @@
 	public function test_get_with_type_group_activity_no_dupes() {
 		$g = $this->factory->group->create();
-		$u1 = $this->create_user();
+		$u1 = $this->factory->user->create();
 		$c = buddypress()->groups->id;
 		$time = time();
@@ -569,11 +569,11 @@
 	public function test_get_with_type_alphabetical() {
 		$g = $this->factory->group->create();
-		$u1 = $this->create_user( array(
+		$u1 = $this->factory->user->create( array(
 			'display_name' => 'AAA',
 		) );
-		$u2 = $this->create_user( array(
+		$u2 = $this->factory->user->create( array(
 			'display_name' => 'CCC',
 		) );
-		$u3 = $this->create_user( array(
+		$u3 = $this->factory->user->create( array(
 			'display_name' => 'BBB',
 		) );
@@ -606,6 +606,6 @@
 	public function test_with_invite_sent_true() {
 		$g = $this->factory->group->create();
-		$u1 = $this->create_user();
-		$u2 = $this->create_user();
+		$u1 = $this->factory->user->create();
+		$u2 = $this->factory->user->create();
 		$time = time();
 
@@ -637,6 +637,6 @@
 	public function test_with_invite_sent_false() {
 		$g = $this->factory->group->create();
-		$u1 = $this->create_user();
-		$u2 = $this->create_user();
+		$u1 = $this->factory->user->create();
+		$u2 = $this->factory->user->create();
 		$time = time();
 
@@ -668,6 +668,6 @@
 	public function test_with_inviter_id_false() {
 		$g = $this->factory->group->create();
-		$u1 = $this->create_user();
-		$u2 = $this->create_user();
+		$u1 = $this->factory->user->create();
+		$u2 = $this->factory->user->create();
 		$time = time();
 
@@ -696,8 +696,8 @@
 	public function test_with_inviter_id_specific() {
 		$g = $this->factory->group->create();
-		$u1 = $this->create_user();
-		$u2 = $this->create_user();
-		$u3 = $this->create_user();
-		$u4 = $this->create_user();
+		$u1 = $this->factory->user->create();
+		$u2 = $this->factory->user->create();
+		$u3 = $this->factory->user->create();
+		$u4 = $this->factory->user->create();
 		$time = time();
 
@@ -736,8 +736,8 @@
 	public function test_with_inviter_id_any() {
 		$g = $this->factory->group->create();
-		$u1 = $this->create_user();
-		$u2 = $this->create_user();
-		$u3 = $this->create_user();
-		$u4 = $this->create_user();
+		$u1 = $this->factory->user->create();
+		$u2 = $this->factory->user->create();
+		$u3 = $this->factory->user->create();
+		$u4 = $this->factory->user->create();
 		$time = time();
 