Index: /trunk/src/bp-notifications/bp-notifications-actions.php
===================================================================
--- /trunk/src/bp-notifications/bp-notifications-actions.php	(revision 9351)
+++ /trunk/src/bp-notifications/bp-notifications-actions.php	(revision 9352)
@@ -126,5 +126,5 @@
  * Handles bulk management (mark as read/unread, delete) of notifications.
  *
- * @since BuddyPress (2.2)
+ * @since BuddyPress (2.2.0)
  *
  * @return bool
Index: /trunk/src/bp-notifications/bp-notifications-cache.php
===================================================================
--- /trunk/src/bp-notifications/bp-notifications-cache.php	(revision 9351)
+++ /trunk/src/bp-notifications/bp-notifications-cache.php	(revision 9352)
@@ -12,5 +12,5 @@
  * @since BuddyPress (2.0.0)
  *
- * @param BP_Notification_Notification $n Notification object.
+ * @param BP_Notifications_Notification $n Notification object.
  */
 function bp_notifications_clear_all_for_user_cache_after_save( BP_Notifications_Notification $n ) {
Index: /trunk/src/bp-notifications/bp-notifications-classes.php
===================================================================
--- /trunk/src/bp-notifications/bp-notifications-classes.php	(revision 9351)
+++ /trunk/src/bp-notifications/bp-notifications-classes.php	(revision 9352)
@@ -139,4 +139,13 @@
 		$data_format = array( '%d', '%d', '%d', '%s', '%s', '%s', '%d' );
 
+		/**
+		 * Fires before the current notification item gets saved.
+		 *
+		 * Please use this hook to filter the properties above. Each part will be passed in.
+		 *
+		 * @since BuddyPress (2.0.0)
+		 *
+		 * @param BP_Notifications_Notification Current instance of the notification item being saved. Passed by reference.
+		 */
 		do_action_ref_array( 'bp_notification_before_save', array( &$this ) );
 
@@ -158,4 +167,11 @@
 		}
 
+		/**
+		 * Fires after the current notification item gets saved.
+		 *
+		 * @since BuddyPress (2.0.0)
+		 *
+		 * @param BP_Notifications_Notification Current instance of the notification item being saved. Passed by reference.
+		 */
 		do_action_ref_array( 'bp_notification_after_save', array( &$this ) );
 
@@ -704,4 +720,13 @@
 		$where = self::get_query_clauses( $args );
 
+		/**
+		 * Fires before the deletion of a notification item.
+		 *
+		 * @since BuddyPress (2.0.0)
+		 *
+		 * @param array $args Associative array of columns/values, to determine
+		 *                    which rows should be deleted. Of the format
+		 *                    array( 'item_id' => 7, 'component_action' => 'members' ).
+		 */
 		do_action( 'bp_notification_before_delete', $args );
 
Index: /trunk/src/bp-notifications/bp-notifications-functions.php
===================================================================
--- /trunk/src/bp-notifications/bp-notifications-functions.php	(revision 9351)
+++ /trunk/src/bp-notifications/bp-notifications-functions.php	(revision 9352)
@@ -152,5 +152,12 @@
 	}
 
-	// Filter and return
+	/**
+	 * Filters all notifications for a user.
+	 *
+	 * @since BuddyPress (2.1.0)
+	 *
+	 * @param array $notifications Array of notifications for user.
+	 * @param int   $user_id       ID of the user being fetched.
+	 */
 	return apply_filters( 'bp_notifications_get_all_notifications_for_user', $notifications, $user_id );
 }
@@ -262,5 +269,11 @@
 				if ( 'object' === $format ) {
 
-					// Retrieve the content of the notification using the callback
+					/**
+					 * Filters the notifications for a user.
+					 *
+					 * @since BuddyPress (1.9.0)
+					 *
+					 * @param array $ref_array Array of properties for the current notification being rendered.
+					 */
 					$content = apply_filters_ref_array( 'bp_notifications_get_notifications_for_user', $ref_array );
 
@@ -282,4 +295,6 @@
 				// Return an array of content strings
 				} else {
+
+					/** This filters is documented in bp-notifications/bp-notifications-functions.php */
 					$renderable[] = apply_filters_ref_array( 'bp_notifications_get_notifications_for_user', $ref_array );
 				}
@@ -293,5 +308,13 @@
 	}
 
-	// Filter and return
+	/**
+	 * Filters the final array of notifications to be displayed for a user.
+	 *
+	 * @since BuddyPress (1.6.0)
+	 *
+	 * @param Array|Bool $renderable Array of notifications to render or false if no notifications.
+	 * @param int        $user_id    ID of the user whose notifications are being displayed.
+	 * @param string     $format     Display format requested for the notifications.
+	 */
 	return apply_filters( 'bp_core_get_notifications_for_user', $renderable, $user_id, $format );
 }
@@ -541,4 +564,11 @@
 	$count         = ! empty( $notifications ) ? count( $notifications ) : 0;
 
+	/**
+	 * Filters the count of unread notification items for a user.
+	 *
+	 * @since BuddyPress (1.9.0)
+	 *
+	 * @param int $count Count of unread notification items for a user.
+	 */
 	return apply_filters( 'bp_notifications_get_total_notification_count', (int) $count );
 }
@@ -572,5 +602,12 @@
 	}
 
-	// Return active components with registered notifications callbacks
+	/**
+	 * Filters active components with registered notifications callbacks.
+	 *
+	 * @since BuddyPress (1.9.1)
+	 *
+	 * @param array $component_names   Array of registered component names.
+	 * @param array $active_components Array of active components.
+	 */
 	return apply_filters( 'bp_notifications_get_registered_components', $component_names, $active_components );
 }
Index: /trunk/src/bp-notifications/bp-notifications-screens.php
===================================================================
--- /trunk/src/bp-notifications/bp-notifications-screens.php	(revision 9351)
+++ /trunk/src/bp-notifications/bp-notifications-screens.php	(revision 9352)
@@ -21,6 +21,19 @@
  */
 function bp_notifications_screen_unread() {
+
+	/**
+	 * Fires right before the loading of the notifications unread screen template file.
+	 *
+	 * @since BuddyPress (1.9.0)
+	 */
 	do_action( 'bp_notifications_screen_unread' );
 
+	/**
+	 * Filters the template to load for the notifications unread screen.
+	 *
+	 * @since BuddyPress (1.9.0)
+	 *
+	 * @param string $template Path to the notifications unread template to load.
+	 */
 	bp_core_load_template( apply_filters( 'bp_notifications_template_unread', 'members/single/home' ) );
 }
@@ -32,6 +45,19 @@
  */
 function bp_notifications_screen_read() {
+
+	/**
+	 * Fires right before the loading of the notifications read screen template file.
+	 *
+	 * @since BuddyPress (1.9.0)
+	 */
 	do_action( 'bp_notifications_screen_read' );
 
+	/**
+	 * Filters the template to load for the notifications read screen.
+	 *
+	 * @since BuddyPress (1.9.0)
+	 *
+	 * @param string $template Path to the notifications read template to load.
+	 */
 	bp_core_load_template( apply_filters( 'bp_notifications_template_read', 'members/single/home' ) );
 }
Index: /trunk/src/bp-notifications/bp-notifications-template.php
===================================================================
--- /trunk/src/bp-notifications/bp-notifications-template.php	(revision 9351)
+++ /trunk/src/bp-notifications/bp-notifications-template.php	(revision 9352)
@@ -27,4 +27,12 @@
 	 */
 	function bp_get_notifications_slug() {
+
+		/**
+		 * Filters the notifications component slug.
+		 *
+		 * @since BuddyPress (1.9.0)
+		 *
+		 * @param string $slug Notifications component slug.
+		 */
 		return apply_filters( 'bp_get_notifications_slug', buddypress()->notifications->slug );
 	}
@@ -47,4 +55,12 @@
 	function bp_get_notifications_permalink() {
 		$retval = trailingslashit( bp_loggedin_user_domain() . bp_get_notifications_slug() );
+
+		/**
+		 * Filters the notifications permalink.
+		 *
+		 * @since BuddyPress (1.9.0)
+		 *
+		 * @param string $retval Permalink for the notifications.
+		 */
 		return apply_filters( 'bp_get_notifications_permalink', $retval );
 	}
@@ -67,4 +83,12 @@
 	function bp_get_notifications_unread_permalink() {
 		$retval = trailingslashit( bp_loggedin_user_domain() . bp_get_notifications_slug() . '/unread' );
+
+		/**
+		 * Filters the unread notifications permalink.
+		 *
+		 * @since BuddyPress (1.9.0)
+		 *
+		 * @param string $retval Permalink for the unread notifications.
+		 */
 		return apply_filters( 'bp_get_notifications_unread_permalink', $retval );
 	}
@@ -87,4 +111,12 @@
 	function bp_get_notifications_read_permalink() {
 		$retval = trailingslashit( bp_loggedin_user_domain() . bp_get_notifications_slug() . '/read' );
+
+		/**
+		 * Filters the read notifications permalink.
+		 *
+		 * @since BuddyPress (1.9.0)
+		 *
+		 * @param string $retval Permalink for the read notifications.
+		 */
 		return apply_filters( 'bp_get_notifications_unread_permalink', $retval );
 	}
@@ -390,4 +422,10 @@
 
 		} elseif ( $this->current_notification + 1 == $this->notification_count ) {
+
+			/**
+			 * Fires right before the rewinding of notification posts.
+			 *
+			 * @since BuddyPress (1.9.0)
+			 */
 			do_action( 'notifications_loop_end');
 
@@ -416,4 +454,10 @@
 		// loop has just started
 		if ( 0 === $this->current_notification ) {
+
+			/**
+			 * Fires if the current notification item is the first in the notification loop.
+			 *
+			 * @since BuddyPress (1.9.0)
+			 */
 			do_action( 'notifications_loop_start' );
 		}
@@ -490,4 +534,12 @@
 	buddypress()->notifications->query_loop = $query_loop;
 
+	/**
+	 * Filters whether or not the user has notifications to display.
+	 *
+	 * @since BuddyPress (1.9.0)
+	 *
+	 * @param bool                      $value      Whether or not there are notifications to display.
+	 * @param BP_Notifications_Template $query_loop BP_Notifications_Template object instance.
+	 */
 	return apply_filters( 'bp_has_notifications', $query_loop->has_notifications(), $query_loop );
 }
@@ -533,4 +585,12 @@
 	 */
 	function bp_get_the_notification_id() {
+
+		/**
+		 * Filters the ID of the notification currently being iterated on.
+		 *
+		 * @since BuddyPress (1.9.0)
+		 *
+		 * @param int $id ID of the notification being iterated on.
+		 */
 		return apply_filters( 'bp_get_the_notification_id', buddypress()->notifications->query_loop->notification->id );
 	}
@@ -552,4 +612,12 @@
 	 */
 	function bp_get_the_notification_item_id() {
+
+		/**
+		 * Filters the associated item ID of the notification currently being iterated on.
+		 *
+		 * @since BuddyPress (1.9.0)
+		 *
+		 * @param int $item_id ID of the associated item.
+		 */
 		return apply_filters( 'bp_get_the_notification_item_id', buddypress()->notifications->query_loop->notification->item_id );
 	}
@@ -571,4 +639,12 @@
 	 */
 	function bp_get_the_notification_secondary_item_id() {
+
+		/**
+		 * Filters the secondary associated item ID of the notification currently being iterated on.
+		 *
+		 * @since BuddyPress (1.9.0)
+		 *
+		 * @param int $secondary_item_id ID of the secondary associated item.
+		 */
 		return apply_filters( 'bp_get_the_notification_secondary_item_id', buddypress()->notifications->query_loop->notification->secondary_item_id );
 	}
@@ -590,4 +666,12 @@
 	 */
 	function bp_get_the_notification_component_name() {
+
+		/**
+		 * Filters the name of the component associated with the notification currently being iterated on.
+		 *
+		 * @since BuddyPress (1.9.0)
+		 *
+		 * @param int $component_name Name of the component associated with the current notification.
+		 */
 		return apply_filters( 'bp_get_the_notification_component_name', buddypress()->notifications->query_loop->notification->component_name );
 	}
@@ -609,4 +693,12 @@
 	 */
 	function bp_get_the_notification_component_action() {
+
+		/**
+		 * Filters the name of the action associated with the notification currently being iterated on.
+		 *
+		 * @since BuddyPress (1.9.0)
+		 *
+		 * @param int $component_action Name of the action associated with the current notification.
+		 */
 		return apply_filters( 'bp_get_the_notification_component_action', buddypress()->notifications->query_loop->notification->component_action );
 	}
@@ -628,4 +720,12 @@
 	 */
 	function bp_get_the_notification_date_notified() {
+
+		/**
+		 * Filters the timestamp of the current notification.
+		 *
+		 * @since BuddyPress (1.9.0)
+		 *
+		 * @param string $date_notified Timestamp of the current notification.
+		 */
 		return apply_filters( 'bp_get_the_notification_date_notified', buddypress()->notifications->query_loop->notification->date_notified );
 	}
@@ -660,4 +760,11 @@
 		}
 
+		/**
+		 * Filters the time since value of the current notification.
+		 *
+		 * @since BuddyPress (1.9.0)
+		 *
+		 * @param string $retval Time since value for current notification.
+		 */
 		return apply_filters( 'bp_get_the_notification_time_since', $retval );
 	}
@@ -693,8 +800,16 @@
 		// Allow non BuddyPress components to hook in
 		} else {
+
+			/** This filter is documented in bp-notifications/bp-notifications-functions.php */
 			$description = apply_filters_ref_array( 'bp_notifications_get_notifications_for_user', array( $notification->component_action, $notification->item_id, $notification->secondary_item_id, 1 ) );
 		}
 
-		// Filter and return
+		/**
+		 * Filters the full-text description for a specific notification.
+		 *
+		 * @since BuddyPress (1.9.0)
+		 *
+		 * @param string $description Full-text description for a specific notification.
+		 */
 		return apply_filters( 'bp_get_the_notification_description', $description );
 	}
@@ -724,4 +839,11 @@
 		<?php $retval = ob_get_clean();
 
+		/**
+		 * Filters the mark read link for the current notification.
+		 *
+		 * @since BuddyPress (1.9.0)
+		 *
+		 * @param string $retval HTML for the mark read link for the current notification.
+		 */
 		return apply_filters( 'bp_get_the_notification_mark_read_link', $retval );
 	}
@@ -761,10 +883,16 @@
 		$url = wp_nonce_url( $url, 'bp_notification_mark_read_' . $id );
 
-		// Filter and return
+		/**
+		 * Filters the URL used for marking a single notification as read.
+		 *
+		 * @since BuddyPress (2.1.0)
+		 *
+		 * @param string $url URL to use for marking the single notification as read.
+		 */
 		return apply_filters( 'bp_get_the_notification_mark_read_url', $url );
 	}
 
 /**
- * Output the mark read link for the current notification.
+ * Output the mark unread link for the current notification.
  *
  * @since BuddyPress (1.9.0)
@@ -776,5 +904,5 @@
 }
 	/**
-	 * Return the mark read link for the current notification.
+	 * Return the mark unread link for the current notification.
 	 *
 	 * @since BuddyPress (1.9.0)
@@ -789,4 +917,11 @@
 		<?php $retval = ob_get_clean();
 
+		/**
+		 * Filters the link used for marking a single notification as unread.
+		 *
+		 * @since BuddyPress (1.9.0)
+		 *
+		 * @param string $retval HTML for the mark unread link for the current notification.
+		 */
 		return apply_filters( 'bp_get_the_notification_mark_unread_link', $retval );
 	}
@@ -826,5 +961,11 @@
 		$url = wp_nonce_url( $url, 'bp_notification_mark_unread_' . $id );
 
-		// Filter and return
+		/**
+		 * Filters the URL used for marking a single notification as unread.
+		 *
+		 * @since BuddyPress (2.1.0)
+		 *
+		 * @param string $url URL to use for marking the single notification as unread.
+		 */
 		return apply_filters( 'bp_get_the_notification_mark_unread_url', $url );
 	}
@@ -853,4 +994,11 @@
 		}
 
+		/**
+		 * Filters the mark link for the current notification.
+		 *
+		 * @since BuddyPress (1.9.0)
+		 *
+		 * @param string $retval The mark link for the current notification.
+		 */
 		return apply_filters( 'bp_get_the_notification_mark_link', $retval );
 	}
@@ -880,4 +1028,11 @@
 		<?php $retval = ob_get_clean();
 
+		/**
+		 * Filters the delete link for the current notification.
+		 *
+		 * @since BuddyPress (1.9.0)
+		 *
+		 * @param string $retval HTML for the delete link for the current notification.
+		 */
 		return apply_filters( 'bp_get_the_notification_delete_link', $retval );
 	}
@@ -927,5 +1082,11 @@
 		$url = wp_nonce_url( $url, 'bp_notification_delete_' . $id );
 
-		// Filter and return
+		/**
+		 * Filters the URL used for deleting a single notification.
+		 *
+		 * @since BuddyPress (2.1.0)
+		 *
+		 * @param string $url URL used for deleting a single notification.
+		 */
 		return apply_filters( 'bp_get_the_notification_delete_url', $url );
 	}
@@ -969,4 +1130,11 @@
 		$retval = $r['before'] . implode( $r['links'], $r['sep'] ) . $r['after'];
 
+		/**
+		 * Filters the action links for the current notification.
+		 *
+		 * @since BuddyPress (1.9.0)
+		 *
+		 * @param string $retval HTML links for actions to take on single notifications.
+		 */
 		return apply_filters( 'bp_get_the_notification_action_links', $retval );
 	}
@@ -995,4 +1163,11 @@
 		$pag        = sprintf( _n( 'Viewing 1 notification', 'Viewing %1$s - %2$s of %3$s notifications', $total, 'buddypress' ), $from_num, $to_num, $total );
 
+		/**
+		 * Filters the pagination count for the current notification loop.
+		 *
+		 * @since BuddyPress (1.9.0)
+		 *
+		 * @param string $pag HTML for the pagination count.
+		 */
 		return apply_filters( 'bp_notifications_pagination_count', $pag );
 	}
@@ -1014,4 +1189,12 @@
 	 */
 	function bp_get_notifications_pagination_links() {
+
+		/**
+		 * Filters the pagination links for the current notification loop.
+		 *
+		 * @since BuddyPress (1.9.0)
+		 *
+		 * @param string $pag_links HTML for the pagination links.
+		 */
 		return apply_filters( 'bp_get_notifications_pagination_links', buddypress()->notifications->query_loop->pag_links );
 	}